-- types.e

--/topic Types
--/type int( i )
--/desc Same as the declaration integer().
--/ret True if /i i is an integer
constant True = (1=1)

global type int( integer i )
    return True
end type

-----------------------------------------------------------------------------
--/topic Types
--/type seq( s )
--/desc Same as the declaration sequence().
--/ret True if /i s is a sequence.

global type seq( sequence s )
    return True
end type


-----------------------------------------------------------------------------
--/topic Types
--/type string( s )
--/desc A sequence that only contains ANSI bytes.
--/ret True if /i s is a string.

global type string( object s )
    if not sequence(s) then
        return 0
    end if
    
    for i = 1 to length(s) do
        if not integer(s[i]) then
            return 0
        end if
        
        if s[i] < 0 or s[i] > 255 then
            return 0
        end if
        
    end for
    return True
end type


